entity JKFF is
  port (SN, RN, J, K, CLK: in bit;	-- inputs
        Q: inout bit; QN: out bit := '1');	-- see Note 1
end JKFF;

architecture JKFF1 of JKFF is
begin
  process (SN, RN, CLK)	-- see Note 2
  begin
    if RN = '0' then  Q<= '0' after 10 ns;	-- RN=0 will clear the FF
    elsif SN = '0'  then  Q<= '1' after 10 ns;	-- SN=0 will set the FF
    elsif CLK = '0' and CLK'event then  	-- see Note 3
      Q <= (J and not Q) or (not K and Q) after 10 ns;   -- see Note 4 
    end if;
  end process;
  QN <= not Q;	-- see Note 5
end JKFF1;


